/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.pointsGoods.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.modules.guosen.pointsGoods.entity.PointsGoods;
import org.springblade.modules.guosen.pointsGoods.vo.PointsGoodsVO;
import org.springblade.modules.guosen.pointsProportion.entity.PointsProportion;
import org.springblade.modules.guosen.pointsProportion.service.IPointsProportionService;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-06-28
 */
public class PointsGoodsWrapper extends BaseEntityWrapper<PointsGoods, PointsGoodsVO> {
	private IPointsProportionService pointsProportionService;

	public PointsGoodsWrapper(IPointsProportionService pointsProportionService) {
		this.pointsProportionService = pointsProportionService;
	}

	public PointsGoodsWrapper() {
	}


	public static PointsGoodsWrapper build(IPointsProportionService pointsProportionService) {
		return new PointsGoodsWrapper(pointsProportionService);
	}
	public static PointsGoodsWrapper build() {
		return new PointsGoodsWrapper();
	}


	@Override
	public PointsGoodsVO entityVO(PointsGoods pointsGoods) {
		PointsGoodsVO pointsGoodsVO = Objects.requireNonNull(BeanUtil.copy(pointsGoods, PointsGoodsVO.class));
		if (pointsGoodsVO != null && pointsProportionService != null) {
			PointsProportion proportion = pointsProportionService.list().get(0);
			BigDecimal divide = pointsGoodsVO.getCashValue().divide(proportion.getPointsProportion());
			pointsGoodsVO.setEqualPoints(divide);
		}
		return pointsGoodsVO;
	}

}
